﻿function placeFloater(position) {
    // turn off all links in markup
    var links = document.querySelectorAll(".Markup p[active]");
    for (var i = 0; i < links.length; i++) {
        links[i].setAttribute("active", false);
    }

    // turn  on the activated link
    document.querySelector(".Markup ." + position).setAttribute("active", true);

    // remove the floater from its current location
    var floater = document.getElementById("Floater");
    var oldPosition = floater.className;
    var placeholder = document.createElement("div");
    placeholder.className = oldPosition;
    floater.parentNode.insertBefore(placeholder, floater);
    floater.parentNode.removeChild(floater);

    var newLocation = document.querySelector("#Example ." + position);
    newLocation.parentNode.insertBefore(floater, newLocation);
    floater.className = newLocation.className;
    newLocation.parentNode.removeChild(newLocation);
}

function switchToFloat(value) {
    var floater = document.getElementById("Floater");
    floater.style.float = value;

    if (value == "left" || value == "right") {
        _Slider.setValue("WidthSlider", 0);
        _Slider.setValue("HeightSlider", 0);
        floater.style.msGridColumn = "";
        floater.style.msGridRow = "";

        // turn on/off the appropriate controls. I'd prefer to do this with an attribute selector in CSS, but there's a bug currently...
        var off = document.querySelectorAll("#controls .Positioned");
        var on = document.querySelectorAll("#controls .Floated");

        for(var i=0; i<off.length; i++) {
            off[i].style.display = "none";
        }
        for(var i=0; i<on.length; i++) {
            on[i].style.display = "block";
        }

        document.getElementById("Example").style.display = "block";

    } else {
        _Slider.setValue("ColumnSlider", 0);
        _Slider.setValue("RowSlider", 0);
        _Slider.setValue("ColumnSpanSlider", 0);
        _Slider.setValue("RowSpanSlider", 0);

        // After //build we updated the syntax to match the new recommendation from the W3C
        floater.style.msWrapSide = "both";
        
        // For Beta we updated the syntax again to match the latest W3C spec
        floater.style.msWrapFlow = "both";

        // reparent the positioned float
        placeFloater("Position1");

        floater.style.width = "100%";
        floater.style.height = "100%";


        var on = document.querySelectorAll("#controls .Positioned");
        var off = document.querySelectorAll("#controls .Floated");

        for(var i=0; i<off.length; i++) {
            off[i].style.display = "none";
        }
        for(var i=0; i<on.length; i++) {
            on[i].style.display = "block";
        }

        document.getElementById("Example").style.display = "-ms-grid";
    }
}

function changeFloatSize(newValue, slider) {
    var floater = document.getElementById("Floater");
    var property = slider.getAttribute("part");
    floater.style[property] = newValue;
}

function updatePositionedFloat(newValue, slider) {
    var floater = document.getElementById("Floater");
    var property = slider.getAttribute("part");
    floater.style[property] = newValue;

    switch (property) {
        case "-ms-grid-column":
            document.getElementById("GridColumnValue").innerHTML = newValue;
            break;
        case "-ms-grid-row":
            document.getElementById("GridRowValue").innerHTML = newValue;
            break;
        case "-ms-grid-column-span":
            document.getElementById("GridColumnSpanValue").innerHTML = newValue;
            break;
        case "-ms-grid-row-span":
            document.getElementById("GridRowSpanValue").innerHTML = newValue;
            break;
    }
}

(function initialize() {
    var elem = document.createElement("div");
    elem.style.msWrapFlow = "invalid";
    if (elem.style.msWrapFlow != "invalid") {
        document.getElementById("syntaxRadioButtonLabel").textContent = "-ms-flow-wrap";
        document.getElementById("markupPositionedSyntax").textContent = "-ms-flow-wrap: both";
    }
})();